package matsubara.plageartest;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import matsubara.uiext.*;
import matsubara.uiext.event.*;

import matsubara.gear.*;
import java.beans.*;



class PlaGearRunThread extends Thread {
  private PlaGearTest m_applet;
  private volatile boolean m_bStopRequest = false;

  /**
   * 䂷vl^MA̓ǗXbh
   * @param applet vl^MAV~[^Avbg̖{
   */
  PlaGearRunThread(PlaGearTest applet) {
    m_applet = applet;
  }
  /**
   * Xbh{
   */
  public void run() {
    long nSleep;
    long nTime, nTime2, nTime3;
    nTime = System.currentTimeMillis();
    nTime3 = System.currentTimeMillis();
    Graphics graphics = m_applet.getGraphics();
    while (m_bStopRequest == false) {
      long nInterval = nTime3 - nTime;
      nTime = nTime3;
//      m_applet.lbStatus.setText(String.valueOf(nInterval != 0 ? 1000 / nInterval : 0) + " fps");
      try {
        m_applet.move(nInterval);
      }
      catch (Exception e) {
        e.printStackTrace();
      }
      try {
        m_applet.draw(m_applet.pnlPlanetaryGear.getGraphics());
      }
      catch (Exception e) {
        e.printStackTrace();
      }
      nTime2 = System.currentTimeMillis();
      nSleep = 50 - (nTime2 - nTime);
      if (nSleep < 10)
        nSleep = 10;
      try {
        sleep(nSleep);
      }
      catch (Exception e) {
      }
      nTime3 = System.currentTimeMillis();
    }
  }
  /**
   * Xbh̒~v𔭍s
   */
  public void stopRequest() {
    m_bStopRequest = true;
  }
}


/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2002</p>
 * <p>Ж: </p>
 * @author 
 * @version 1.1.0
 */

public class PlaGearTest extends Applet {
  PlanetaryGear m_plaGear = null;
  Image m_img;
  int m_nImageWidth = 200;
  int m_nImageHeight = 200;
  PlaGearRunThread m_threadRun;
  boolean m_bSliderOperation = false;


  boolean isStandalone = false;
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  Panel pnlPlanetaryGear = new Panel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Button btRingGearStop = new Button();
  Button btPlaCarrierStop = new Button();
  Button btSunGearStop = new Button();
  Label label1 = new Label();
  Label lbRingGearSpeed = new Label();
  Label label3 = new Label();
  Label lbPlanetaryCarrerSpeed = new Label();
  Label label5 = new Label();
  Label lbSunGearSpeed = new Label();
  Label label7 = new Label();
  TextField txRingGear = new TextField();
  Label label8 = new Label();
  TextField txSunGear = new TextField();
  Label label9 = new Label();
  TextField txPinionGear = new TextField();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  Label label10 = new Label();
  Button btGearChange = new Button();
  Slider sliPlanetaryCarrier = new Slider();
  Slider sliRingGear = new Slider();
  Slider sliSunGear = new Slider();
  TextField txPinionGearNumber = new TextField();
  Label lbStatus = new Label();
  //l̎擾
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Avbg̍\z
  public PlaGearTest() {
  }
  //Avbg̏
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private GridBagConstraints newGridBagConstraints(int nGridX, int nGridY, int nGridWidth, int nGridHeight
        , double nWeightX, double nWeightY, int nAnchor, int nFill, Insets insets, int nIpadX, int nIpadY) {
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.gridx = nGridX;
    constraints.gridy = nGridY;
    constraints.gridwidth = nGridWidth;
    constraints.gridheight = nGridHeight;
    constraints.weightx = nWeightX;
    constraints.weighty = nWeightY;
    constraints.anchor = nAnchor;
    constraints.fill = nFill;
    constraints.insets = insets;
    constraints.ipadx = nIpadX;
    constraints.ipady = nIpadY;
    return constraints;
  }



  //R|[lg̏
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    panel2.setLayout(gridBagLayout1);
    btRingGearStop.setLabel("~");
    btRingGearStop.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btRingGearStop_actionPerformed(e);
      }
    });
    btPlaCarrierStop.setLabel("~");
    btPlaCarrierStop.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btPlaCarrierStop_actionPerformed(e);
      }
    });
    btSunGearStop.setLabel("~");
    btSunGearStop.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btSunGearStop_actionPerformed(e);
      }
    });
    label1.setFont(new java.awt.Font("Dialog", 0, 12));
    label1.setForeground(new Color(0, 191, 0));
    label1.setText("OMA");
    lbRingGearSpeed.setAlignment(2);
    lbRingGearSpeed.setForeground(new Color(0, 191, 0));
    lbRingGearSpeed.setText("0rpm");
    label3.setFont(new java.awt.Font("Dialog", 0, 8));
    label3.setForeground(Color.red);
    label3.setText("vl^LA");
    lbPlanetaryCarrerSpeed.setAlignment(2);
    lbPlanetaryCarrerSpeed.setForeground(Color.red);
    lbPlanetaryCarrerSpeed.setText("0rpm");
    label5.setFont(new java.awt.Font("Dialog", 0, 12));
    label5.setForeground(Color.blue);
    label5.setText("TMA");
    lbSunGearSpeed.setAlignment(2);
    lbSunGearSpeed.setForeground(Color.blue);
    lbSunGearSpeed.setText("0rpm");
    label7.setFont(new java.awt.Font("Dialog", 0, 12));
    label7.setForeground(new Color(0, 191, 0));
    label7.setText("OMA");
    txRingGear.setText("78");
    txRingGear.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        txRingGear_keyReleased(e);
      }
    });
    label8.setFont(new java.awt.Font("Dialog", 0, 12));
    label8.setForeground(Color.blue);
    label8.setText("TMA");
    txSunGear.setText("30");
    txSunGear.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        txSunGear_keyReleased(e);
      }
    });
    label9.setBackground(Color.orange);
    label9.setFont(new java.awt.Font("Dialog", 0, 12));
    label9.setForeground(Color.darkGray);
    label9.setText("sjIMA");
    txPinionGear.setText("23");
    txPinionGear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        txPinionGear_actionPerformed(e);
      }
    });
    txPinionGear.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        txPinionGear_keyReleased(e);
      }
    });
    panel1.setLayout(gridBagLayout2);
    label10.setBackground(Color.orange);
    label10.setFont(new java.awt.Font("Dialog", 0, 12));
    label10.setForeground(Color.darkGray);
    label10.setText("sjIMA");
    btGearChange.setFont(new java.awt.Font("Dialog", 0, 12));
    btGearChange.setLabel("MAύX");
    btGearChange.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btGearChange_actionPerformed(e);
      }
    });
    sliPlanetaryCarrier.setMaximum(10000);
    sliPlanetaryCarrier.setMinimum(-10000);
    sliPlanetaryCarrier.setMajorTickSpacing(2000);
    sliPlanetaryCarrier.setMinorTickSpacing(1000);
    sliPlanetaryCarrier.setPrintLabel(true);
    sliPlanetaryCarrier.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliPlanetaryCarrier_stateChanged(e);
      }
    });
    sliPlanetaryCarrier.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliPlanetaryCarrier_stateChanged(e);
      }
    });
    sliRingGear.setMaximum(10000);
    sliRingGear.setMinimum(-10000);
    sliRingGear.setMajorTickSpacing(2000);
    sliRingGear.setMinorTickSpacing(1000);
    sliRingGear.setPrintLabel(true);
    sliRingGear.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliRingGear_stateChanged(e);
      }
    });
    sliRingGear.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliRingGear_stateChanged(e);
      }
    });
    sliRingGear.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliRingGear_stateChanged(e);
      }
    });
    sliRingGear.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliRingGear_stateChanged(e);
      }
    });
    sliRingGear.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliRingGear_stateChanged(e);
      }
    });
    sliSunGear.setMaximum(10000);
    sliSunGear.setMinimum(-10000);
    sliSunGear.setMajorTickSpacing(2000);
    sliSunGear.setMinorTickSpacing(1000);
    sliSunGear.setPrintLabel(true);
    sliSunGear.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliSunGear_stateChanged(e);
      }
    });
    sliSunGear.addChangeListener(new matsubara.uiext.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliSunGear_stateChanged(e);
      }
    });
    txPinionGearNumber.setText("4");
    txPinionGearNumber.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        txPinionGearNumber_keyReleased(e);
      }
    });
    lbStatus.setFont(new java.awt.Font("Dialog", 0, 12));
    lbStatus.setText(" ");
    this.setBackground(Color.white);
    this.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        this_componentResized(e);
      }
    });
    pnlPlanetaryGear.setBackground(Color.white);
    panel2.setBackground(Color.white);
    panel1.setBackground(Color.white);
    this.add(panel1, BorderLayout.SOUTH);

    panel1.add(label7,          newGridBagConstraints(0, 0, 1, 4, 0.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(label8,          newGridBagConstraints(2, 0, 1, 5, 0.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(txSunGear,            newGridBagConstraints(3, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 50, 0));
    panel1.add(label9,          newGridBagConstraints(4, 0, 1, 5, 0.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(txPinionGear,          newGridBagConstraints(5, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 50, 0));
    panel1.add(label10,           newGridBagConstraints(1, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 32, 0));
    panel1.add(txRingGear,    newGridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 50, 0));
    panel1.add(txPinionGearNumber,            newGridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 50, 0));
    panel1.add(btGearChange,    newGridBagConstraints(5, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(lbStatus,     newGridBagConstraints(0, 2, 6, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    this.add(panel2,  BorderLayout.EAST);
    panel2.add(btPlaCarrierStop,               newGridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(btRingGearStop,             newGridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(btSunGearStop,            newGridBagConstraints(2, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(label1,          newGridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(lbRingGearSpeed,           newGridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(label3,         newGridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(lbPlanetaryCarrerSpeed,           newGridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(label5,         newGridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(lbSunGearSpeed,           newGridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(sliPlanetaryCarrier,                                             newGridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(0, 0, 0, 0), 15, 70));
    panel2.add(sliRingGear,                           newGridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(0, 3, 0, 0), 15, 70));
    panel2.add(sliSunGear,      newGridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(0, 0, 0, 0), 15, 70));
    this.add(pnlPlanetaryGear, BorderLayout.CENTER);
  }
  //Avbg̊Jn
  public void start() {
    m_img = createImage(200, 200);

    btGearChange_actionPerformed(null);

    m_threadRun = new PlaGearRunThread(this);
    m_threadRun.start();
    showSpeed();
  }
  //Avbg̒~
  public void stop() {
    m_threadRun.stopRequest();
  }
  //Avbg̔j
  public void destroy() {
  }
  //Avbg̏擾
  public String getAppletInfo() {
    return "VԃeXgAvbg version 1.1.0";
  }
  //̎擾
  public String[][] getParameterInfo() {
    return null;
  }
  //Main \bh
  public static void main(String[] args) {
    PlaGearTest applet = new PlaGearTest();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame() {
      protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("VԁEeXgAvbg");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
//    applet.start();
    frame.setSize(640,480);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);

    applet.start();
  }


  synchronized public void paint(Graphics g) {
    super.paint(g);
    if (m_plaGear != null) {
      Graphics gi = m_img.getGraphics();
      gi.setColor(Color.white);
      gi.fillRect(0, 0, m_nImageWidth, m_nImageHeight);
      m_plaGear.draw(gi);
      try {
        g.drawImage(m_img, 0, 0, null);
      } catch (Exception e) {
      }
    }
  }

  synchronized public void move(long nTime) {
    m_plaGear.move(nTime / 200.0);
  }

  synchronized public void draw(Graphics g) {
    if (m_plaGear != null) {
      Graphics gi = m_img.getGraphics();
      gi.setColor(Color.white);
      gi.fillRect(0, 0, m_nImageWidth, m_nImageHeight);
      m_plaGear.draw(gi);
      g.drawImage(m_img, 0, 0, null);
    }
  }

  synchronized public void resize() {
    if (pnlPlanetaryGear.getSize().width * pnlPlanetaryGear.getSize().height != 0) {
      m_nImageWidth = pnlPlanetaryGear.getSize().width;
      m_nImageHeight = pnlPlanetaryGear.getSize().height;
    }
    else {
      m_nImageWidth = 100;
      m_nImageHeight = 100;
    }
    m_img = createImage(m_nImageWidth, m_nImageHeight);
    double rSize = ((m_nImageWidth < m_nImageHeight) ? m_nImageWidth : m_nImageHeight) * 0.8 / 2.0;
    if (rSize < 50.0)
      rSize = 50.0;
    if (m_plaGear != null) {
      m_plaGear.setPosX(m_nImageWidth / 2);
      m_plaGear.setPosY(m_nImageHeight / 2);
      m_plaGear.setSize(rSize);
    }
  }

  public void showSpeed() {
    lbRingGearSpeed.setText(String.valueOf((int)(m_plaGear.getRingGearSpeed() - m_plaGear.getRingGearSpeed() % 10)) + "rpm");
    lbPlanetaryCarrerSpeed.setText(String.valueOf((int)(m_plaGear.getPlaCarrierSpeed() - m_plaGear.getPlaCarrierSpeed() % 10)) + "rpm");
    lbSunGearSpeed.setText(String.valueOf((int)(m_plaGear.getSunGearSpeed() - m_plaGear.getSunGearSpeed() % 10)) + "rpm");
  }

  void btGearChange_actionPerformed(ActionEvent e) {
    int nRingGear = 0;
    int nSunGear = 0;
    int nPinionGear = 0;
    int nPinionGearNumber = 0;

    try {
      try {
        nRingGear = Integer.parseInt(txRingGear.getText());
        nSunGear = Integer.parseInt(txSunGear.getText());
        nPinionGear = Integer.parseInt(txPinionGear.getText());
        nPinionGearNumber = Integer.parseInt(txPinionGearNumber.getText());
      } catch (RuntimeException ex) {
      }
      if (nRingGear == 0)
        throw new Exception("OMA̒lsł");
      if (nSunGear == 0)
        throw new Exception("TMA̒lsł");
      if (nPinionGear == 0)
        throw new Exception("sjIMA̒lsł");
      if (nPinionGearNumber == 0)
        throw new Exception("sjIMA̒lsł");
      m_plaGear = new PlanetaryGear(130, 130, 100, nSunGear, nPinionGear, nRingGear, 6, nPinionGearNumber);
      lbStatus.setText("");
    }
    catch (Exception ex) {
      lbStatus.setText(ex.getMessage());
      ex.printStackTrace();
    }
    resize();
    sliRingGear.setValue(0);
    sliPlanetaryCarrier.setValue(0);
    sliSunGear.setValue(0);
    paint(getGraphics());
  }

  boolean m_bOnSliderChanging = false;

  void sliRingGear_stateChanged(ChangeEvent e) {
    if (m_bOnSliderChanging == false) {
      m_bOnSliderChanging = true;
      try {
        m_plaGear.setRingGearSpeed(sliRingGear.getValue());
  //      sliRingGear.setValue((int)(m_plaGear.getRingGearSpeed() + 0.5));
        sliPlanetaryCarrier.setValue((int)(m_plaGear.getPlaCarrierSpeed() + 0.5));
        sliSunGear.setValue((int)(m_plaGear.getSunGearSpeed() + 0.5));
        showSpeed();
      } finally {
        m_bOnSliderChanging = false;
      }
    }
  }

  void sliPlanetaryCarrier_stateChanged(ChangeEvent e) {
    if (m_bOnSliderChanging == false) {
      m_bOnSliderChanging = true;
      try {
        m_plaGear.setPlaCarrierSpeed(sliPlanetaryCarrier.getValue());
  //      sliRingGear.setValue((int)(m_plaGear.getRingGearSpeed() + 0.5));
  //      sliPlanetaryCarrier.setValue((int)(m_plaGear.getPlaCarrierSpeed() + 0.5));
        sliSunGear.setValue((int)(m_plaGear.getSunGearSpeed() + 0.5));
        showSpeed();
      } finally {
        m_bOnSliderChanging = false;
      }
    }
  }

  void sliSunGear_stateChanged(ChangeEvent e) {
    if (m_bOnSliderChanging == false) {
      m_bOnSliderChanging = true;
      try {
        m_plaGear.setSunGearSpeed(sliSunGear.getValue());
  //      sliRingGear.setValue((int)(m_plaGear.getRingGearSpeed() + 0.5));
        sliPlanetaryCarrier.setValue((int)(m_plaGear.getPlaCarrierSpeed() + 0.5));
  //      sliSunGear.setValue((int)(m_plaGear.getSunGearSpeed() + 0.5));
        showSpeed();
      } finally {
        m_bOnSliderChanging = false;
      }
    }
  }

  void btRingGearStop_actionPerformed(ActionEvent e) {
    m_plaGear.setRingGearSpeed(0);
    sliRingGear.setValue((int)m_plaGear.getRingGearSpeed());
    sliSunGear.setValue((int)m_plaGear.getSunGearSpeed());
    showSpeed();
  }

  void btPlaCarrierStop_actionPerformed(ActionEvent e) {
    m_plaGear.setPlaCarrierSpeed(0);
    sliPlanetaryCarrier.setValue((int)m_plaGear.getPlaCarrierSpeed());
    sliSunGear.setValue((int)m_plaGear.getSunGearSpeed());
    showSpeed();
  }

  void btSunGearStop_actionPerformed(ActionEvent e) {
    m_plaGear.setSunGearSpeed(0);
    sliSunGear.setValue((int)m_plaGear.getSunGearSpeed());
    sliPlanetaryCarrier.setValue((int)m_plaGear.getPlaCarrierSpeed());
    showSpeed();
  }

  void txRingGear_keyReleased(KeyEvent e) {
    try {
      int nRingGear = Integer.parseInt(txRingGear.getText());
      int nSunGear = Integer.parseInt(txSunGear.getText());
      txPinionGear.setText(String.valueOf((nRingGear - nSunGear) / 2));
    } catch (Exception ex) {
    }
  }

  void txSunGear_keyReleased(KeyEvent e) {
    try {
      int nRingGear = Integer.parseInt(txRingGear.getText());
      int nSunGear = Integer.parseInt(txSunGear.getText());
      txPinionGear.setText(String.valueOf((nRingGear - nSunGear) / 2));
    } catch (Exception ex) {
    }
  }

  void txPinionGear_keyReleased(KeyEvent e) {
    //
  }

  void txPinionGearNumber_keyReleased(KeyEvent e) {
    //
  }

  void txPinionGear_actionPerformed(ActionEvent e) {

  }

  void this_componentResized(ComponentEvent e) {
    resize();
  }
}